using GatherService.WattMeter.AnalysisData.AFN_10H;
using JiShe.CollectBus.Common.Extensions;
using JiShe.CollectBus.Protocol.Contracts.Protocol.Dto;
using JiShe.CollectBus.Protocol.Dto;
using JiShe.CollectBus.Protocol.Interfaces;
using JiShe.CollectBus.Protocol3761;
using Microsoft.Extensions.Logging;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using TouchSocket.Core;

namespace JiShe.CollectBus.Protocol.T37612012.AnalysisData.AFN_10H
{
    /// <summary>
    /// 5.16 数据转发（AFN=10H）
    /// </summary>
    public class AFN16_F1_Analysis : IAnalysisStrategy<TB3761>
    {
        private readonly ILogger<AFN16_F1_Analysis> _logger;

        public AFN16_F1_Analysis(ILogger<AFN16_F1_Analysis> logger)
        {
            _logger = logger;
        }

        public Task<bool> ExecuteAsync(TB3761 input, Action<dynamic>? result = null)
        {
            try
            {
                ArgumentNullException.ThrowIfNull(input);
                ArgumentNullException.ThrowIfNull(input.UnitData.HexMessageList);
                UnitDataAnalysis<string> dto = new UnitDataAnalysis<string>
                {
                    Code = input.A.Code!,
                    AFN = input.AFN_FC.AFN,
                    Fn = input.DT.Fn,
                    Pn = input.DA.Pn,
                    Data = AnalysisDataUnit(input.UnitData.HexMessageList),
                    HexMessage = input.BaseHexMessage.HexMessageString,
                    MessageId = input.MessageId,
                    ReceivedTime = input.ReceivedTime
                };
                result?.Invoke(dto);
                return Task.FromResult(true);
            }
            catch (Exception ex)
            {
                _logger.LogError(ex, $"10_101解析失败:{input.A?.Code}-{input.DT?.Fn ?? 0}-{input?.BaseHexMessage?.HexMessageString},{ex.Message}");

            }
            return Task.FromResult(false);
        }


        private string AnalysisDataUnit(List<string> hexMessageList)
        {
            // TODO: 待定，等确认如何匹配规则
            string value = string.Join(" ", hexMessageList);
            if (value.Contains(F10TranspondMatch.ReadNormal))
            {
                if (value.Contains(F10TranspondMatch.PowerHz))//电网频率
                  return  "AFN16_F97_Analysis";
                //else if (value.Contains(F10TranspondMatch.ReadData))//读取电表地址
                //    result = "AFN16_F105_Analysis";
            }
            return "";
        }

    }
}
